#!/usr/bin/perl

#
### CONTROL PANEL SCRIPT FOR ULTIMATE BULLETIN BOARD ##
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1997-2000.
#
#       ------------ cpanel3.cgi -------------
#
#  This file contains some of the control panel functionality for
#  the UBB.  It is called from the controlpanel pages (cp.html).
#
#  NOTE: you MAY NOT redistribute this script under any
#  circumstance.  This means that you may not sell, trade, or in
#  any other way give this script to another user who is not
#  licensed to use it.  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB, 
# see http://www.UltimateBB.com
#
###############################################################
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

print ("Content-type: text/html\n\n");
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "mods.file";
require "UltBB.setup";
require "ubb_library.pl";
require "ubb_library2.pl";
require "Date.pl";
};

if ($@) {
    print "Fehler beim Aufruf der Datei(en): $@\n";
    print "Stellen Sie sicher, da&szlig; diese Datei(en) vorhanden ist/sind, die Zugriffsrechte und Systempfade korrekt eingestellt sind.";
 exit;
}


&ReadParse;

#create random numbers for headers/footers

if (-e "$ForumsPath/Forum$number/forumstyles.file") {
require "$ForumsPath/Forum$number/forumstyles.file";
$Header = $ForumHeader unless ($ForumHeader eq '');
$Footer = $ForumFooter unless ($ForumFooter eq '');
}


if( ($Header ne "") || ($Footer ne "") ) {
	#create random numbers for headers/footers
	$RandomNumber = &MakeRandomNumber;
	$RandomNumber2 = $RandomNumber + 100074;

 if ($Header ne "") {
   $Header =~ s/UBBrandomX/$RandomNumber/isg;
   $Header =~ s/UBBrandomY/$RandomNumber2/isg;
 }
 if ($Footer ne "") {
   $Footer =~ s/UBBrandomX/$RandomNumber/isg;
   $Footer =~ s/UBBrandomY/$RandomNumber2/isg;
 }

}


foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	

	if ($Name eq "number") {
		$number = $Value;
		$number =~ s/\D//g;
	}
	if ($Name eq "Number") { # NB value for creating new forum
		$Number = $Value;
		$Number =~ s/\D//g;
	}
	if ($Name eq "UpdateType") {
		$UpdateType = $Value;
	}		
	if ($Name eq "TotalForums") {
		$TotalForums = $Value;
	}
	if ($Name eq "UserNameCheck") {
		$UserNameCheck = $Value;
		$UserNameCheckFile = $UserNameCheck;
		$UserNameCheckFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserName = &UNHTMLIFY($UserName);
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "Password") {
		$Password = $Value;
		$Password = &UNHTMLIFY($Password);
	}
	if ($Name eq "PasswordCheck") {
		$PasswordCheck = $Value;
	}
	if ($Name eq "action") {
		$action = $Value;
	}
			
} #end foreach loop


if ($action eq "forums") {
&Forums;
}
if ($action eq "setforums") {
&SetForums;
}
if ($action eq "sendforum") {
&SendForum;
}
if ($action eq "addnewforum") {
&AddNewForum;
}
if ($action eq "cats") {
&Cats;
}
if ($action eq "ContinueLastTimes") {
&SetLastTimesCycle;
}
if ($action eq "ContinueThreadNums") {
&SetLastThreadNumsCycle;
}
if ($action eq "setcats") {
&SetCats;
}
if ($action eq "viewbanlist") {
&ViewBanList;
}
if ($action eq "submitbans") {
&SubmitBans;
}
if ($action eq "getforum") {
&GetForum;
}

sub GetForum {
&AssembleCats;

if (-e "$ForumsPath/Forum$number/forumstyles.file") {
require "$ForumsPath/Forum$number/forumstyles.file";
$ForumHeader =~ s/\\@/\@/sg;
$ForumHeader =~ s/\\"/\"/sg;
$ForumFooter =~ s/\\@/\@/sg;
$ForumFooter =~ s/\\"/\"/sg;
}  else {
require "$VariablesPath/Styles.file";
$ForumHeader = "";
$ForumFooter = "";
}

&get_cookie;  #retrieves all current cookies
if ($cookie{UserNameCP}) {
$CheckUserName = "$cookie{UserNameCP}";
$CheckPassword = "$cookie{PasswordCP}";
}
elsif ($in{'UserName'}) {
$CheckUserName = $in{'UserName'};
$CheckPassword = $in{'Password'};
}  else {
$PageTitle = "F O R U M &nbsp;&nbsp; - &nbsp;&nbsp; E I N S T E L L U N G E N";
$PageIntro = "Um Ver&auml;nderungen an den Foren vornehmen zu k&ouml;nnen, m&uuml;ssen Sie sich identifizieren - wir setzen einen Cookie auf Ihren PC, so da&szlig; diese Identifikation je Browser-Sitzung nur einmalig durchzuf&uuml;hren ist.";
$HiddenFields = qq(<INPUT TYPE="HIDDEN" NAME="action" VALUE="getforum"><INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
 );
&QueryForID;
exit;
}

#confirm permission to read forum data
&VerifyAdminCP($CheckUserName, $CheckPassword);
if ($Proceed eq "true") {
$UserName = $CheckUserName;
$Password = $CheckPassword;

my @forums = &OpenForumsFile;
my @CATEGORIES = &OpenFile("$NonCGIPath/categories.file");

#print Forum File
$PageTitle = "F O R U M &nbsp;&nbsp; - &nbsp;&nbsp; E I N S T E L L U N G E N";
&HEADER2HTML;

print<<ForumHTML;
<FONT SIZE="1" FACE="Verdana, Arial">Hier k&ouml;nnen Sie Forum-Namen, Beschreibungen und individuelle Einstellungen vornehmen.</FONT> 
<FONT SIZE="2" FACE="Verdana, Arial">
<P>
<B>Gehe zu: </B><A HREF="$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true">&Uuml;bersicht der Foren</A> | <A HREF="$CGIURL/cpanel3.cgi?action=cats">Kategorien bearbeiten</A>
<P>
<table border=0 width=95%><TR><TD>
<B><FONT SIZE="2" FACE="Verdana, Arial">Update Ihres Forums:</FONT></B></td><TD align=center><FONT SIZE="1" FACE="Verdana, Arial">[<A HREF="$NonCGIURL/forumterms.html" target=_new>Erkl&auml;rung der Forum-Variablen</A>]</FONT></td></TR></table>

<P>
<TABLE BORDER=0 cellspacing=0 cellpadding=0 width=95%><TR><td bgcolor="#000000">

<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
ForumHTML

$ForumNumber = $number;
$ArrayLine = $ForumNumber - 1;
$ThisForum = $forums[$ArrayLine];

		@thisforum = split(/\|/, $ThisForum);
		
		chomp($thisforum[10]);
		chomp($thisforum[11]);
		chomp($thisforum[12]);
		chomp($thisforum[13]);
		chomp($thisforum[14]);

unless (-e "$ForumsPath/Forum$number/forumstyles.file") {
if ($thisforum[9] ne "") {
$BBTitle = $thisforum[9];
}
}  

my $CategoryDropDown = qq(<SELECT NAME="Category">);
if ($thisforum[0] eq "") {
	$ThisSelection = "SELECTED";
}  else {
	$ThisSelection = "";
}

$CategoryDropDown .= qq(<OPTION VALUE="" $ThisSelection>Keine Kategorie);
$Count = 0;
foreach $cat(@CATEGORIES) {
$Count++;
($Junk, $CatName, $CatNumber) = split(/\|\|\|/, $cat);
chomp($CatNumber);
if ($CatNumber == $thisforum[0]) {
	$Selection = "SELECTED";
} else {
	$Selection = "";
}
$CategoryDropDown .= qq(<OPTION VALUE="$CatNumber" $Selection>$CatName);
}


if ($Count == 0) {
$CategoryDropDown .= qq(<OPTION value="">Keine Kategorien vorhanden);
}
$CategoryDropDown .= "</SELECT>";
		
		if ($thisforum[2] ne '') {
		$forumdescription = "$thisforum[2]";	
		}
		
		if ($thisforum[3] eq "On") {
			$ForumActive = "CHECKED";
		}  else {
			$ForumInactive = "CHECKED";
		}
		if ($thisforum[13] eq "no") {
			$PrivateMaxNo = "CHECKED";
		}  else {
			$PrivateMaxYes = "CHECKED";
		}
		if ($thisforum[4] eq "is") {
			$HTMLOn = "CHECKED";
		}  else {
			$HTMLOff = "CHECKED";
		}
		if ($thisforum[5] eq "is") {
			$UBBOn = "CHECKED";
		}  else {
			$UBBOff = "CHECKED";
			}
if ($thisforum[10] eq "OFF") {
			$UBBImagesOff = "CHECKED";
		}  else {
			$UBBImagesOn = "CHECKED";
		}

if ($thisforum[11] eq "yes") {
			$ModNotifyOn = "CHECKED";
		}  else {
			$ModNotifyOff = "CHECKED";
		}
		
if ($thisforum[6] eq "yes") {
	$TRrestrictOn = "SELECTED";
	$RRrestrictOn = "SELECTED";
}
if ($thisforum[6] eq "private") {
	$PrivateOn = "CHECKED";
	$TRrestrictOn = "SELECTED";
	$RRrestrictOn = "SELECTED";
}
if ($thisforum[6] eq "partly") {
	$TRrestrictOn = "SELECTED";
	$RRallregOn = "SELECTED";
}
if ($thisforum[6] eq "includenonreg") {
	$TRallOn = "SELECTED";
	$RRallOn = "SELECTED";
}
if ($thisforum[6] eq "no") {
	$TRallregOn = "SELECTED";
	$RRallregOn = "SELECTED";
}
		
if (($thisforum[6] =~ /\&/) && ($thisforum[6] ne "private")){
		($TopicRestrict, $ReplyRestrict) = split(/\&/, $thisforum[6]);
		if ($TopicRestrict eq "restrict") {
			$TRrestrictOn = "SELECTED";
		}
		elsif ($TopicRestrict eq "allreg") {
			$TRallregOn = "SELECTED";
		} else  {
			$TRallOn = "SELECTED";
		}
		if ($ReplyRestrict eq "restrict") {
			$RRrestrictOn = "SELECTED";
		}
		elsif ($ReplyRestrict eq "allreg") {
			$RRallregOn = "SELECTED";
		}
		elsif ($ReplyRestrict eq "all") {
			$RRallOn = "SELECTED";
		}  else  {
			$RRnoneOn = "SELECTED";
		}
	}
			$TitleGraphic = "$thisforum[9]";


### If UBB Code is off, UBB Code for Images must also be off! ###
	if ($UBBOff eq "CHECKED") {
			$UBBImagesOn = "";
			$UBBImagesOff = "CHECKED";
		}

print<<ForumGuts;
<table border=0 width=100%>
<tr bgcolor="#D3CE87">
<td colspan=4 valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<B>Nummer des Forums: $ForumNumber</B></td></tr>
<TR bgcolor="#c7c6ba">
<TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Name:</B></FONT></td>
<td colspan="2"><INPUT TYPE="TEXT" NAME="Namer" VALUE="$thisforum[1]" SIZE=30 MAXLENGTH=100></td></tr>
<tr bgcolor="#d5d2bb"><td><FONT SIZE="1" FACE="Verdana, Arial"><B>
Kategorie:</B></FONT></td>
<td colspan="2">$CategoryDropDown</td></tr>

<TR bgcolor="#C7C6BA"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>Status:</B></FONT></td>
<td colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="Status" VALUE="On" $ForumActive> An &nbsp;&nbsp;&nbsp;&nbsp;
<INPUT TYPE="RADIO" NAME="Status" VALUE="Off" $ForumInactive> Aus</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>HTML-Code erlaubt?</B></FONT></td><TD colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="HTML" VALUE="is" $HTMLOn> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="HTML" VALUE="is not" $HTMLOff> Nein</B></FONT></td></tr>

<TR bgcolor="#C7C6BA"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>UBB-Code erlaubt?</B></FONT></td><TD colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="UBB" VALUE="is" $UBBOn> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="UBB" VALUE="is not" $UBBOff> Nein</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>UBB-Code inklusive Grafiken?</B></FONT></td><TD colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="UBBImages" VALUE="ON" $UBBImagesOn> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="UBBImages" VALUE="OFF" $UBBImagesOff> Nein</B></FONT></td></tr>

<TR bgcolor="#C7C6BA" ><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>Information an den Moderator? <BR></B><FONT SIZE="1" FACE="Verdana, Arial">Ist diese Funktion aktiviert, erh&auml;lt der Moderator eine eMail, sobald in diesem Forum ein neuer Beitrag erstellt worden ist (nicht empfohlen!).</FONT></FONT></td><TD valign=top colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="ModNotify" VALUE="yes" $ModNotifyOn> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="ModNotify" VALUE="no" $ModNotifyOff> Nein</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial" color="#800000"><B>Zugriffsrechte</B></font><BR><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen dieses Forum als privates Forum definieren, was bedeutet, da&szlig; lediglich Administratoren, Moderatoren oder Benutzer, denen Sie den Zugriff gew&auml;hren in diesem Forum lesen oder schreiben k&ouml;nnen. Wenn Sie ein Kennwort f&uuml;r dieses Forum vergeben, k&ouml;nnen Benutzer, denen das Kennwort bekannt ist, ebenfalls darauf zugreifen. 
<P>
Wenn Sie dieses Forum nicht als v&ouml;llig privates Forum definieren m&ouml;chten, k&ouml;nnen Sie den Zugriff auf verschiedene Varianten limitieren. 
<P>
<BR><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Forum-Kennwort:</font> <INPUT TYPE="TEXT" NAME="forumpw" VALUE="$thisforum[12]" SIZE=12 MAXLENGTH=12>
</FONT></td><TD valign=top colspan="2"><FONT SIZE="1" FACE="Verdana, Arial"><B>
<CENTER>Private Foren - Schreiben/Lesen</CENTER><P>
<INPUT TYPE="CHECKBOX" NAME="Private" VALUE="private" $PrivateOn>
Das Forum auf Administratoren, Moderatoren und andere autorisierte<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">*</FONT> Benutzer einschr&auml;nken. 
<P>
Wenn Sie das Forum limitiert haben, k&ouml;nnen Sie durch die Auswahl der maximalen Sicherheit alle Anzeigen in diesem Forum dynamisch einstellen, so da&szlig; der Benutzer sich vor jeder Anzeige mit Benutzernamen und dem entsprechenden Kennwort legitimieren mu&szlig;. Bei minimaler Sicherheit werden die Beitr&auml;ge in einer HTML-Datei gespeichert, so da&szlig; der Aufruf bei geringerer Sicherheit direkt vom Server schneller erfolgen kann. 
<blockquote>
<INPUT TYPE="RADIO" NAME="PrivateMax" VALUE="yes" $PrivateMaxYes>Maximale Sicherheit<BR>
<INPUT TYPE="RADIO" NAME="PrivateMax" VALUE="no" $PrivateMaxNo>Minimale Sicherheit
</blockquote>
<HR>
<BR>
<CENTER>Limitation des Erstellen von Beitr&auml;gen<br>(Ansicht aller Beitr&auml;ge ist jedoch m&ouml;glich)</CENTER>
<P>
Ist Ihr Forum nichtg als privates Forum definiert, k&ouml;nnen Sie hier einstellen, wer auf Beitr&auml;ge antworten oder neue Beitr&auml;ge erstellen darf. 
<P>
Wer darf Beitr&auml;ge erstellen?
<BR>
<SELECT NAME="TopicRestrict">
<option value="restrict" $TRrestrictOn>Nur Administratoren, Moderatoren oder autorisierte Benutzer
<option value="allreg" $TRallregOn>Alle registrierten Benutzer
<option value="all" $TRallOn>Alle Benutzer, auch unregistrierte
</SELECT>
<P>

Wer darf antworten?
<BR>
<SELECT NAME="ReplyRestrict">
<option value="restrict" $RRrestrictOn>Nur Administratoren, Moderatoren oder autorisierte Benutzer
<option value="allreg" $RRallregOn>Alle registrierten Benutzer
<option value="all" $RRallOn>Alle Benutzer, auch unregistrierte
<option value="none" $RRnoneOn>Es d&uuml;rfen keine Antworten erstellt werden
</SELECT>

</B></FONT>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">* Ein autorisierter Benutzer ist ein Benutzer, welcher kein Administrator oder Moderator ist, sondern durch einen Administrator in seinem Benutzer-Eintrag einen Zugang zu diesem Forum freigeschalten oder das Forum-Kennwort &uuml;bermittelt bekommen hat.</FONT></p>
</td></tr>
ForumGuts

#&InputAreaRow("#d5d2bb", "<p>Custom Header", "You can add your own customized header graphic, ad banner, text, etc. for this forum.  This header will appear at the top of each UBB forum page.  The Header you set in your Style settings will be used if you keep this field blank.  Thus, only complete this field is you want to replace the default Header that you set in your Style settings.</p>", "ForumHeader", "30", "5");

#&InputAreaRow("#c7c6ba", "<p>Custom Footer", "You can add your own customized header graphic, ad banner, text, etc. for this forum.  This header will appear at the bottom of each UBB forum page.  The Footer you set in your Style settings will be used if you keep this field blank.  Thus, only complete this field is you want to replace the default Footer that you set in your Style settings.</p>", "ForumFooter", "30", "5");

print<<MoreForumGuts;

<TR bgcolor="#c7c6ba" ><TD valign=top><FONT SIZE="2" FACE="Verdana, Arial"><B>Beschreibung des Forums:</B></FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Dieser Text wird in der Foren-&Uuml;bersicht unter dem Namen des Forums als Beschreibung gezeigt. Beachten Sie, da&szlig; zur korrekten Anzeige in den generellen Einstellungen die Funktion "Forum-Beschreibungen anzeigen?" auf "Ja" eingestellt sein mu&szlig;!</font></td><td valign=top  colspan="3"><TEXTAREA NAME="Description" ROWS=3 COLS=40 wrap="VIRTUAL">$forumdescription</TEXTAREA></td></tr>
<TR bgcolor="#d5d2bb"><td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Individuelle Kopfzeile</B></FONT>
<FONT SIZE="1" FACE="Verdana, Arial"><BR>Sie k&ouml;nnen diesem Forum einen individuellen Kopf zur Darstellung zuweisen, die ggf. vorhandenen Daten des Kopfs in den Darstellungs-Einstellungen werden dann &uuml;berschrieben.</FONT></p>
</td>
<td width=50% valign=top colspan=2>
<TEXTAREA NAME="ForumHeader" COLS="40" ROWS="5" WRAP="VIRTUAL">$ForumHeader</TEXTAREA>
</td></tr>

<TR bgcolor="#c7c6ba">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Individuelle Fu&szlig;zeile</B></FONT>
<FONT SIZE="1" FACE="Verdana, Arial"><BR>Sie k&ouml;nnen diesem Forum einen individuellen Fu&szlig; zur Darstellung zuweisen, die ggf. vorhandenen Daten des Fu&szlig; in den Darstellungs-Einstellungen werden dann &uuml;berschrieben.</FONT></p>
</td>
<td width=50% valign=top colspan="2">
<TEXTAREA NAME="ForumFooter" COLS="40" ROWS="5" WRAP="VIRTUAL">$ForumFooter</TEXTAREA>
</td></tr>

<TR bgcolor="#D3CE87">
<td colspan=3 valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<B>Darstellung des Forums</B><P>HINWEIS: Die Standardwerte zur Darstellung von UBB werden in dem Men&uuml; Darstellung definiert. Hier k&ouml;nnen Sie jedem Forum ein individuelles Aussehen zuweisen. M&ouml;chten Sie eigene Grafiken verwenden, m&uuml;ssen diese per FTP in Ihr NonCGI-Verzeichnis &uuml;bertragen werden.</font></td></tr>
MoreForumGuts

&ColorRow("Hintergrundfarbe", "Format - #FFFFFF", "BGColor", "#D5D2BB");
&ColorRow("Schriftfarbe", "", "TextColor", "#C7C6BA");
&ColorRow("Farbe eines Links", "", "LinkColor", "#D5D2BB");
&ColorRow("Farbe eines aktiven Links", "", "ActiveLinkColor", "#C7C6BA");
&ColorRow("Farbe eines besuchten Links", "", "VisitedLinkColor", "#D5D2BB");
&ColorRow("Farbe des Tabellenrands", "", "TableBorderColor", "#C7C6BA");
&ColorRow("Tabellenkopf - Schriftfarbe", "", "TableStripTextColor", "#D5D2BB");
&ColorRow("Tabellenkopf - Hintergrundfarbe", "", "TableColorStrip", "#C7C6BA");
&ColorRow("Farbe der Zeitangaben", "Diese Farbe wird zur Darstellung der Zeitfelder in der Hauptseite sowie der &Uuml;bersicht eines Forums von UBB sowie der \"erstellt von\"-Zeile f&uuml;r jeden Beitrag verwendet.", "TimeColor", "#D5D2BB");
&ColorRow("Erste Zeilenfarbe in Tabellen", "", "AltColumnColor1", "#C7C6BA");
&ColorRow("Zweite Zeilenfarbe in Tabellen", "", "AltColumnColor2", "#D5D2BB");
&ColorRow("Kategorie-Zeile - Hintergrundfarbe", "", "CategoryStripColor", "#C7C6BA");
&ColorRow("Kategorie-Zeile - Schriftfarbe", "", "CategoryStripTextColor", "#D5D2BB");
&ColorRow("Copyright - Schriftfarbe", "", "CopyrightTextColor", "#C7C6BA");

print<<ForumGuts2;
<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Schriftart (z.B. Verdana)</B></FONT><br><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen den Einsatz von mehreren Schriftarten. Als Beispiel: Benutzen Sie Verdana als erste Wahl, Arial als Schriftart f&uuml;r die Benutzer, welche Verdana nicht auf ihrem System installiert haben. Mehrere Schriftarten geben Sie so an: "Verdana, Arial".</FONT><br>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="FontFace" VALUE="$FontFace" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Tabellenbreite</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen die Tabellenbreite in Pixel (empfohlen: 600 Pixel) oder als Prozent-Angabe (empfohlen: 90%) angeben.</FONT></p>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="TableWidth" VALUE="$TableWidth" SIZE=5 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Schriftgr&ouml;&szlig;e</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen die Gr&ouml;&szlig;e 2 - abh&auml;ngig von der von Ihnen verwendete Schriftart k&ouml;nnen Sie diesen Wert entsprechend anpassen.</FONT></p>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="TextSize" VALUE="$TextSize" SIZE=1 MAXLENGTH=1>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Hintergrund-Grafik</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Nicht empfohlen, jedoch k&ouml;nnen Sie eine Hintergrund-Grafik f&uuml;r die Anzeige Ihrer Seiten definieren. Wenn ja, sollten Sie die entsprechende Grafik-Datei in das NonCGI-Verzeichnis von UBB uploaden und den Namen hier eintragen. Beispiel: hintergrund.gif.</FONT></p>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="PageBackground" VALUE="$PageBackground" SIZE=30 MAXLENGTH=200>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Titel-/Logo-Grafik:</B></FONT></td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="BBTitle" VALUE="$BBTitle" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Beitrag erstellen - Grafik:</B></FONT>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="BBTopic" VALUE="$BBTopic" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Antwort erstellen - Grafik:</B></FONT>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="BBReply" VALUE="$BBReply" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Beitrag geschlossen - Grafik:</B></FONT>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="ThreadClosed" VALUE="$ThreadClosed" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Profil - Grafik:</B></FONT>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="profilegif" VALUE="$profilegif" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>eMail - Grafik:</B></FONT>
</td>
<td valign=top colspan="2">
<INPUT TYPE="TEXT" NAME="mailgif" VALUE="$mailgif" SIZE=25 MAXLENGTH=50>
</td></tr>
</table>
ForumGuts2

print<<BottomForumHTML;
</td></tr></table>
<BR><INPUT TYPE="CHECKBOX" NAME="RestoreDefaultStyles" VALUE="yes">

<FONT SIZE="1" FACE="Verdana, Arial">Markieren Sie dieses Feld, wenn Sie die standardm&auml;&szlig;igen Darstellungsoptionen wieder herstellen m&ouml;chten.</FONT>
<INPUT TYPE="HIDDEN" NAME="ForumNumber" VALUE="$ForumNumber">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="sendforum">
<CENTER>
<P>
<HR>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Bitte identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></FONT></B>
<p><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern"></form>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000000">Infopop Corporation &copy; 2000<br>Ultimate Bulletin Board $Version</FONT><br> <br>
</CENTER></font>
</BODY>
</HTML>
BottomForumHTML


} else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};

&StandardHTMLCP("Zur Ansicht der Foren-Einstellungen sind Sie nicht autorisiert.");
exit;
}

} #end sr

sub SubmitBans {

&log_admin_activity ("SubmitBans") if ($log_admin_activity eq 'YES');
	
&VerifyAdminCP($UserNameCheck, $PasswordCheck);
if ($Proceed eq "true") {
$EmailBans = $in{'EmailBan'};
#$EmailBans =~ s/\@/\\@/g; # rem to prevent later problems with quotemeta in CheckBans routine
@EmailBanList = split(/\s/, $EmailBans);

$IPBans = $in{'IPBan'};
$IPBans =~ s/\@/\\@/g;
@IPBanList = split(/\s/, $IPBans);

&Lock("lock.file");
open(EMAILBAN, ">$NonCGIPath/BanLists/EmailBan.cgi");
foreach $one(@EmailBanList) {
	chomp($one);
	if ($one ne "") {
	print EMAILBAN "$one\n";
	}
}
close(EMAILBAN);
&Unlock("lock.file");
chmod (0777, "$NonCGIPath/BanLists/EmailBan.cgi");

&Lock("lock.file");
open(IPBAN, ">$NonCGIPath/BanLists/IPBan.cgi");
foreach $uno(@IPBanList) {
	chomp($uno);
	if ($uno ne "") {
	print IPBAN "$uno\n";
	}
}
close(IPBAN);
&Unlock("lock.file");
chmod (0777, "$NonCGIPath/BanLists/IPBan.cgi");

&EndUpdate("S P E R R L I S T E N &nbsp;&nbsp;&nbsp;&nbsp; W U R D E N &nbsp;&nbsp;&nbsp;&nbsp; A K T U A L I S I E R T", "Die Sperrlisten f&uuml;r IP-Nummern und Mitgliedernamen wurden erfolgreich aktualisiert!");
}
} #end Submit Bans

sub ViewBanList {

&VerifyAdminCP($UserName, $Password);
if ($Proceed eq "true") {

&log_admin_activity ("ViewBanList") if ($log_admin_activity eq 'YES');	

#get current ban lists

@emailbans = &OpenFile("$NonCGIPath/BanLists/EmailBan.cgi");
@IPbans = &OpenFile("$NonCGIPath/BanLists/IPBan.cgi");

$Count = 0;
foreach $one(@emailbans) {
	$emailbans[$Count] =~ s/\\@/@/sg;
	$Count++;
}

$EmailBan = join(/\n/, @emailbans);
$IPBan = join(/\n/, @IPbans);

$PageTitle = "S P E R R L I S T E N";
&HEADER2HTML;

print<<BANNED;
<FONT SIZE="2" FACE="Verdana, Arial">Sie k&ouml;nnen bestimmte Benutzer oder Benutzergruppen von der Registrierung durch die eMail-oder IP-Adresse ausschlie&szlig;en.</FONT> 
<P>

<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM">

<CENTER>
<table border=0 cellpadding=0 cellspacing=0 width="95%"><TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<TR bgcolor="#B0BB9D">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<p><B>Sperrung einer eMail-Adresse:</b>Hier k&ouml;nnen Sie spezifische eMail-Adressen sperren, wie zum Beispiel waldo\@hundedorf.de. Auch die Sperrung ganzer Domains ist m&ouml;glich, geben Sie dann z.B. einfach hundedorf.de ein. Best&auml;tigen Sie jede Eingabe einer Adresse mit der Return-Taste.</B></p></FONT>
</TD>
</tr>
BANNED

&InputAreaRow("#f7f7f7", "Gesperrte eMail-Adressen:", "", "EmailBan", "30", "5");

print<<NEXT;
<TR bgcolor="#B0BB9D">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<p><B>Sperrung einer IP-Nummer:</b>  Hier k&ouml;nnen Sie spezifische IP-Nummern eingeben, Benutzer mit dieser IP-Nummer k&ouml;nnen sich nicht registrieren oder Beitr&auml;ge verfassen. Geben Sie z.B. einfach 243.21.31.7 ein. Auch eine Sperrung durch die teilweise Angabe der IP-Nummer (z.B. 243.21.31) ist m&ouml;glich, dann k&ouml;nnen alle Benutzer, deren IP-Nummer so beginnt, keine Beitr&auml;ge erstellen oder sich registrieren.</B></p></FONT>
</TD>
</tr>
NEXT

&InputAreaRow("#f7f7f7", "Gesperrte IP-Nummern:", "", "IPBan", "30", "5");

print<<BOTTOM;
<TR bgcolor="#C7C6BA">
<TD><FONT Size="2" FACE="Verdana, Arial">
Benutzername:</font></TD><TD><INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25></td></tr>
<TR bgcolor="#C7C6BA">
<TD><FONT Size="2" FACE="Verdana, Arial">Kennwort</font></TD><TD><INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></TD></tr>
</table>
</td></tr></table>
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submitbans">

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
</FORM>
<P><BR>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version</FONT></CENTER>
</body></html>
BOTTOM


}  
}  #end ViewBanList

sub Forums {
#check to see if categories file has been created
&AssembleCats;

if ($in{'inside'} eq "true") {
#check cookies rather than an input form
&get_cookie;  #retrieves all current cookies

if ($cookie{UserNameCP}) {
$UserName = "$cookie{UserNameCP}";
$Password = "$cookie{PasswordCP}";
&VerifyAdminCP($UserName, $Password);

if ($Proceed eq "true") {
	&DoForums;
} else {

eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("F&uuml;r die Ansicht der Foren-&Uuml;bersicht sind Sie nicht autorisiert.");
exit;
}

} 
elsif ($in{'UserName'} ne "") {

$UserName = "$in{'UserName'}";
$Password = "$in{'Password'}";
&VerifyAdminCP($UserName, $Password);

if ($Proceed eq "true") {
	&DoForums;
} else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("F&uuml;r die Ansicht der Foren-&Uuml;bersicht sind Sie nicht autorisiert.");
exit;
}


}  else {
$PageTitle = "F O R U M &nbsp;&nbsp; - &nbsp;&nbsp; E I N S T E L L U N G E N";
$PageIntro = "F&uuml;r die Ansicht der Foren-&Uuml;bersicht identifizieren Sie sich bitte - wir setzen ein Cookie, so das die Identifikation pro Browser-Sitzung einmalig stattfindet.";
$HiddenFields = qq(<INPUT TYPE="HIDDEN" NAME="action" VALUE="forums">
<INPUT TYPE="HIDDEN" NAME="inside" VALUE="true">
<INPUT TYPE="HIDDEN" NAME="StartPoint" VALUE="0">
<INPUT TYPE="HIDDEN" NAME="sortby" VALUE="$in{'sortby'}">
 );
&QueryForID;
exit;
}

}  else {

# Verify that user is ADMIN first!
&VerifyAdminCP($UserName, $Password);
if ($Proceed eq "true") {
	&DoForums;
 }  else {
 eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("Ihre Identit&auml;t konnte nicht best&auml;tigt werden. Bitte greifen Sie auf die Forum-Einstellungen grunds&auml;tzlich &uuml;ber den entsprechenden Link in der System-Administration zu.");
exit;
}
}
} #end Forums sr

sub DoForums {

if ($UserNameCheck ne "") {
$UserNameFill = "$UserNameCheck";
}  else {
$UserNameFill = "$UserName";
}
$UserNameFill = &HTMLIFY($UserNameFill);

if ($PasswordCheck ne "") {
$PasswordFill = "$PasswordCheck";
}  else {
$PasswordFill = "$Password";
}
$PasswordFill = &HTMLIFY($PasswordFill);

# check to see how many forums are currently listed
@forums = &OpenForumsFile;
$ForumTotal = @forums;

$PageTitle = "F O R U M &nbsp;&nbsp; - &nbsp;&nbsp; E I N S T E L L U N G E N";
&HEADER2HTML;

if ($in{'sortby'} eq "Category") {
	$SortByCategory = "SELECTED";
	$SortIt = "Category";
}
elsif (($in{'sortby'} eq "") || ($in{'sortby'} eq "Number")) {
	$SortByNumber = "SELECTED";
		$SortIt = "Number";
	
}  else {
	$SortByAlpha = "SELECTED";
	$SortIt = "Alpha";
}
print<<ForumHTML;
<FONT SIZE="1" FACE="Verdana, Arial">Hier k&ouml;nnen Sie Forum-Namen, Beschreibungen und individuelle Einstellungen vornehmen.</FONT> 
<P><FONT SIZE="2" FACE="Verdana, Arial">
<B>Klicken Sie <A HREF="$CGIURL/cpanel.cgi?action=addforums">hier</a>, um ein neues Forum zu erstellen.</font></B>
<P>
<table border=0 width=95%><TR><TD>
<B><FONT SIZE="2" FACE="Verdana, Arial">Update der existierenden Foren:</FONT></B></td><TD align=center><FONT SIZE="1" FACE="Verdana, Arial">[<A HREF="$NonCGIURL/forumterms.html" target=_new>Erkl&auml;rung der Forum-Variablen</A>]</FONT></td></TR></table>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">Es existieren derzeit <b>$ForumTotal Foren</b> (aktiv oder inaktiv).<br>Um Zugriffsrechte oder Details einzelner Foren zu ver&auml;ndern, nutzen Sie bitte den Link "Details" auf der rechten Seite neben dem Forum. 
<P>
Das Feld "Sortierung" zeigt die Anzeige-Reihenfolge auf der Startseite von UBB an. Bitte verwenden Sie hier ausschlie&szlig;lich Zahlen. Beispiel: Besitzt ein Forum die Zahl 1, wird es als erstes dargestellt, die 2 als zweites etc. Wenn Sie Kategorien verwenden, gilt die Reihenfolge innerhalb der jeweiligen Kategorie. 
<P>
<TABLE BORDER=0 width=100%>
<TR><TD align=left valign=bottom><FONT SIZE="2" FACE="Verdana, Arial">
<A HREF="$CGIURL/cpanel.cgi?action=addforums">Forum hinzuf&uuml;gen</a> | <A HREF="$CGIURL/cpanel3.cgi?action=cats">Kategorien bearbeiten</A></font></TD>
<TD align=right valign=bottom>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="forums">
<INPUT TYPE="HIDDEN" NAME="inside" VALUE="true">
<INPUT TYPE="HIDDEN" NAME="StartPoint" VALUE="0">
<SELECT NAME="sortby">
	<OPTION value="Category" $SortByCategory>Sortieren nach Kategorie und Forumnummer
	<OPTION value="Number" $SortByNumber>Sortieren nach Forumnummer
	<OPTION value="Alpha" $SortByAlpha>Alphabetisch sortieren
</SELECT><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Sortieren">

</FORM>
</td></TR>
</TABLE>

</FONT>
ForumHTML

#retreive category list
@CATEGORIES = &OpenFile("$NonCGIPath/categories.file");

if ($SortIt eq "Alpha") {
foreach $check(@forums) {
@getalpha = split(/\|/, $check);
$AlphaUC = uc($getalpha[1]);
$AlphaLine = "$AlphaUC||**||$check";
push(@sortthis, $AlphaLine);
}
@sorted = sort(@sortthis);
foreach $uno(@sorted) {
($junk, $keep) = split(/\|\|\*\*\|\|/, $uno);
chomp($keep);
push(@final, $keep);
}

} 
elsif ($SortIt eq "Number") {
@final = @forums;
}  else {

@final = @blank;
@sortcat = sort(@CATEGORIES);
if (@sortcat) {

foreach $cattype(@sortcat) {

($junk, $ThisCatNam, $ThisCatNumb) = split(/\|\|\|/, $cattype);
chomp($ThisCatNumb);

@catgroup = @blank;
@sortthis = @blank;

foreach $check(@forums) {
if ($check =~ /^$ThisCatNumb\|/) {
push(@catgroup, $check);
}
}

#now sort the subset
	foreach $ion(@catgroup) {
		@sortrow = split(/\|/, $ion);
		chomp($sortrow[14]);
		$sortline = "$sortrow[14]||**||$ion";
		push(@sortthis, $sortline);
	}
	@presort = sort(@sortthis);
	@subtotal = (@subtotal, @presort);
}  #end cat loop

#check for forums witout cats

foreach $check(@forums) {
if ($check =~ /^\|/) {
	$Empties = "true";
	chomp($check);
		@thisrow = split(/\|/, $check);
		chomp($thisrow[14]);
		if ($thisrow[14]) {
			$OrdIt = $thisrow[14];
		} else {
			$OrdIt = $thisrow[8];
		}
		$sortline = "$OrdIt||**||$check";
		push(@nocat, $sortline);
}
}
if ($Empties eq "true") {
	@presort2 = sort(@nocat);
	@subtotal = (@subtotal, @presort2);
}
	
	foreach $uno(@subtotal) {
	($junk, $keep) = split(/\|\|\*\*\|\|/, $uno);
	chomp($keep);
	push(@final, $keep);
	}
	
}  else {

	foreach $ion(@forums) {
		@sortrow = split(/\|/, $ion);
		chomp($sortrow[14]);
		$sortline = "$sortrow[14]||**||$ion";
		push(@sortthis, $sortline);
	}
	@subtotal = sort(@sortthis);

	foreach $uno(@subtotal) {
	($junk, $keep) = split(/\|\|\*\*\|\|/, $uno);
	chomp($keep);
	push(@final, $keep);
	}
}
}

## BREAK UP INTO CHUNKS OF 30 ##
$TotalForums = @final;
$MaxForumDisplay = 30;
if ($TotalForums > $MaxForumDisplay) {
$TotalPages = $TotalForums / $MaxForumDisplay;

if ($TotalPages =~ /\./) {
	($Whole, $junk) = split(/\./, $TotalPages);
	$TotalPages = $Whole + 1;
}  else {
	$TotalPages = $TotalPages;
}

if (($in{'StartPoint'} eq "") || ($in{'StartPoint'} == 0)){
	$StartPoint = 0;
} else {
	$StartPoint = $in{'StartPoint'};
	$StartPoint = $StartPoint + 0;
}

	$Calibrate = $StartPoint + 1;
	$EndPoint = $StartPoint + ($MaxForumDisplay - 1);
	$CalibrateEnd = $EndPoint + 1;
	if ($TotalForums < $CalibrateEnd) {
		$CalibrateEnd = $TotalForums;
		$EndPoint = $CalibrateEnd - 1;
	}

$eachpage = 1;

$NextLine = "Forum Number Ranges: &nbsp;&nbsp;&nbsp;&nbsp;";
for ($eachpage == 1; $eachpage <= $TotalPages; $eachpage++) {
$EndHere = $eachpage * $MaxForumDisplay;
$StartHere = $EndHere - ($MaxForumDisplay - 1);
$ArrayStart = $StartHere - 1;
if ($TotalForums < $EndHere) {
	$EndHere = $TotalForums;
}
if ($Calibrate == $StartHere) {
$NextLine .= qq(&nbsp;$StartHere - $EndHere&nbsp;);
}  else {
$NextLine .= qq(&nbsp;<A HREF="$CGIURL/cpanel3.cgi?action=forums&StartPoint=$ArrayStart&sortby=$in{'sortby'}&inside=true">$StartHere - $EndHere</A>&nbsp;)
}

}

@final = @final[$StartPoint...$EndPoint];



} else {
$NextLine = "";

} #if/else more than 40 forums

################################

#display forum summary

print<<SummHead;
$NextLine
<center>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM">
<table border=0 cellpadding=0 cellspacing=0 width="95%"><TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>

<TR bgcolor="Olive"><TD COLSPAN=6 align=center>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="White"><B>&Uuml;bersicht der Foren</B></FONT>
</TR>
<TR bgcolor="#B8C6AE">
<TD><FONT SIZE="2" FACE="Verdana, Arial">Nummer</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Name</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Sortierung</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Status</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Kategorie</font></TD>
<TD>&nbsp;</TD>
</TR>
SummHead


foreach $one(@final) {
@thisfor = split(/\|/, $one);
$ThisNum = $thisfor[8];
$ThisCategory = $thisfor[0];
$OrderNum = $thisfor[14];
chomp($OrderNum);
$OrderNumber = $OrderNum + 0;

if ($thisfor[3] eq "On") {
	$StatusOn = "SELECTED";
	$StatusOff = "";
}  else {
	$StatusOff = "SELECTED";
	$StatusOn = "";
}

unless ($OrderNum) {
	$OrderNumber = $ThisNum;
}

$CategoryDropDown = qq(<SELECT NAME="ForumCategory|||$ThisNum">);
$Count = 0;
if ($ThisCategory eq "") {
	$ThisSelected = "SELECTED";
} else {
	$ThisSelected = "";
}
$CategoryDropDown .= qq(<OPTION VALUE="" $ThisSelected>Keine Kategorie);
foreach $cat(@CATEGORIES) {
($Junk, $CatName, $CatNumber) = split(/\|\|\|/, $cat);
chomp($CatNumber);
$CatNumber = $CatNumber + 0;
$Count++;
if ($CatNumber == $ThisCategory) {
	$Selection = "SELECTED";
} else {
	$Selection = "";
}
$CategoryDropDown .= qq(<OPTION VALUE="$CatNumber" $Selection>$CatName);
}


if ($Count == 0) {
$CategoryDropDown .= qq(<OPTION value="">Keine Kategorien vorhanden);
}
$CategoryDropDown .= "</SELECT>";

print<<ROW;
<TR bgcolor="#FFFFFF">
<TD><FONT SIZE="2" FACE="Verdana, Arial">$ThisNum</font></TD>
<TD><INPUT TYPE="TEXT" NAME="ForumName|||$ThisNum" VALUE="$thisfor[1]" SIZE=20 MAXLENGTH=125></TD>
<TD><INPUT TYPE="TEXT" NAME="ForumOrder|||$ThisNum" VALUE="$OrderNumber" SIZE=5 MAXLENGTH=5></TD>
<TD><SELECT NAME="ForumStatus|||$ThisNum">
	<OPTION value="On" $StatusOn>An
	<OPTION value="Off" $StatusOff>Aus
</SELECT></TD>
<TD>$CategoryDropDown</TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial"><A HREF="$CGIURL/cpanel3.cgi?action=getforum&number=$ThisNum">Details</A></font></TD>
</TR>
ROW

}

print<<BottomForumHTML;
</table>
</td></tr></table>
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="setforums">

<BR>

<P>
<HR>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Bitte identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></FONT></B>
<p><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern"></form>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000000">Infopop Corporation &copy; 2000<br>Ultimate Bulletin Board $Version</FONT> <br><br>
</CENTER></font>
</BODY>
</HTML>
BottomForumHTML
}  ## END DoForums


sub HEADER2HTML {
&GetCookieInfo;
print<<HEADER2HTML;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var testUserNameCP = getCookie("UserNameCP");
var CookieUNCP = escape("$UserName");
var CookiePWCP = escape("$Password");

	if (testUserNameCP == null) {
	  	document.cookie = "UserNameCP=" + CookieUNCP + ";domain=$TheDomain;path=/$ThePath;";
		document.cookie = "PasswordCP=" + CookiePWCP + ";domain=$TheDomain;path=/$ThePath;";
	}

function SetCursor() {
var testUserNameCP = getCookie("UserNameCP");

if (testUserNameCP != null) {  
	document.THEFORM.UserNameCheck.value = getCookie("UserNameCP");
document.THEFORM.PasswordCheck.value = getCookie("PasswordCP");
	}  
}
function Check(form)  {
if ((form.PasswordCheck.value == "") || (form.UserNameCheck.value == ""))  {
	alert ("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort angeben!");
	return false
	}  else  {
	return true
	}
}
function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#000080" onLoad="SetCursor()">
<BR><center>
<FONT SIZE="2" FACE="Verdana, Arial">$PageTitle</FONT>
</center>
<p>
HEADER2HTML
} #end HEADERHTML2 sr


sub SetForums {
&VerifyAdminCP($in{'UserNameCheck'}, $in{'PasswordCheck'});
if ($Proceed eq "true") {
	 &DoProcessForums;
}
}  ##END SendForums sr

sub DoProcessForums {
### write forum info to forums.cgi

&log_admin_activity ("DoProcessForums") if ($log_admin_activity eq 'YES');

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name =~ m/ForumName/) {
	($Trash, $ForumNumber) = split(/\|\|\|/, $Name);
	push (@AdjustForums, $ForumNumber);
	}
} # end foreach $row

# now we have list of forum numbers to adjust (e.g., 1 - 9)

#read current forum data
@forums = &OpenForumsFile;

#assemble new line for each revised forum
for $num(@AdjustForums) {
chomp($num);
	$Found = "false";
	$ThisPrivate = "";
foreach $row2(@in) {
	($Name, $Value) = split ("=", $row2);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name eq "ForumName|||$num") {
		$ThisName = $Value;
		$ThisName =~ s/"/&quot;/g;
		$Found = "true";
	}
	if ($Name eq "ForumCategory|||$num") {
		$ThisCategory = $Value;
	}
	if ($Name eq "ForumStatus|||$num") {
		$ThisStatus = $Value;
	}
		if ($Name eq "ForumOrder|||$num") {
		$ThisOrder = $Value;
		$ThisOrderFormatted = &Do6Digit($ThisOrder);
	}
} # end foreach $row2

$arrayrow = ($num - 1);

$ThisForumLine = $forums[$arrayrow];
chomp($ThisForumLine);
@thisforum = split(/\|/, $ThisForumLine);

$forums[$arrayrow] = ("$ThisCategory|$ThisName|$thisforum[2]|$ThisStatus|$thisforum[4]|$thisforum[5]|$thisforum[6]|$thisforum[7]|$num|$thisforum[9]|$thisforum[10]|$thisforum[11]|$thisforum[12]|$thisforum[13]|$ThisOrderFormatted\n");

}  #end for each @AdjustForum

#write to forums file

&Lock("lock.file");
open (FORUMS, ">$VariablesPath/forums.cgi") || die (&StandardHTMLCP("Die Datei forums.cgi konnte nicht zum Schreiben ge&ouml;ffnet werden.<P>Hier die Fehlermeldung:<p>$!")); 
print FORUMS (@forums);
close (FORUMS);
&Unlock("lock.file");

$UserNameCoded = &HTMLIFY($UserNameCheck);
$PasswordCoded = &HTMLIFY($PasswordCheck);

&EndUpdate("E I N S T E L L U N G E N &nbsp;&nbsp;&nbsp;&nbsp; D E R  &nbsp;&nbsp;&nbsp;&nbsp; F O R E N &nbsp;&nbsp;&nbsp;&nbsp; G E S P E I C H E R T", "Vielen Dank! Die Einstellung Ihrer Foren wurde erfolgreich aktualisiert.<P><P>Gehe zu: <A HREF=\"$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true\">&Uuml;bersicht der Foren</A> | <A HREF=\"$CGIURL/cpanel.cgi?action=addforums\">Neues Forum erstellen</A> | <A HREF=\"$CGIURL/cpanel3.cgi?action=cats\">Einstellung der Kategorien</A>");
exit;
} ## END DO PROCESS FORUMS SR

sub AddNewForum {
### CHECK USERNAME - must be an admin
##verify that this user is an administrator

$NameFound = "no";
$ProfileNumber = &GetUserNumber($in{'UserName'});

if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}


if ($NameFound eq "yes") {
	@profilestats = &OpenProfile("$ProfileNumber.cgi");			
	if ($Password eq "$profilestats[1]") {
	$Permission = "$profilestats[4]";
	&CheckPermissions;
	   if ($AdminPermission eq "true") {
	   &DoAddNewForum;
	   }  else {
	   eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Administratoren verf&uuml;gbar.");
	   }
	} else {
	eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
	&StandardHTMLCP("Das von Ihnen eingegebene Kennwort ist falsch - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	}
}  else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("Der von Ihnen eingegebene Benutzername ist dem System nicht bekannt  - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
}  ##END IF/ELSE NAME CHECK BLOCK

}  ##END AddNewForum sr

sub DoAddNewForum {
$ForumTotal = &GetTotalForums;
$ForumTotal++;

if ($in{'forumpw'} =~ /\|/) {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("In einem Kennwort f&uuml;r ein Forum d&uuml;rfen Sie das Symbol Pipe \"|\" nicht verwenden - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}
### write forum info to forums.cgi
	$Description = &decodeURL($in{'Description'});
		$Description =~ s/"/&quot;/g;
		$Description =~ s/\n\r\n//g;
		$Description =~ s/\n//g;
		$Description =~ s/\r//g;
		$Description =~ s/  / /g;
		
	$Name = &decodeURL($in{'Namer'});
	$Name =~ s/"/&quot;/g;
	$Category = $in{'Category'};
	
	
$ThisForumLine = $forums[$arrayrow];
@thisforum = split(/\|/, $ThisForumLine);

if ($in{'Private'} eq "private") {
#create HTML directory alternate to keep contents hidden
$DIRPW = &GeneratePassword;
$DescLength = length($Description);
$DIRPW .= "$DescLength";
}  else {
$DIRPW = "";
}

if ($in{'Private'} eq "private") {
	$ForumPermission = "private";
}  else {
	$ForumPermission = "$in{'TopicRestrict'}&$in{'ReplyRestrict'}";
}
$OrderNumber = &Do6Digit($ForumTotal);

$newforumline = ("$Category|$Name|$Description|$in{'Status'}|$in{'HTML'}|$in{'UBB'}|$ForumPermission|$DIRPW|$ForumTotal||$in{'UBBImages'}|$in{'ModNotify'}|$in{'forumpw'}|$in{'PrivateMax'}|$OrderNumber");

#write to forums file
&Lock("lock.file");
open (NEWFORUM, ">>$VariablesPath/forums.cgi")|| die (&StandardHTMLCP("Die Datei forums.cgi kann nicht zum Schreiben ge&ouml;ffnet werden.  Hier die Fehlermeldung: $!")); 
print NEWFORUM ("$newforumline\n");
close (NEWFORUM);
&Unlock("lock.file");

$Number = $ForumTotal; # make sure Forum number is the next available [auto correct for people making multiple forums with the back button]

#create new Forum Directory with permissions for UNIX servers
mkdir("$ForumsPath/Forum$Number", 0777);
chmod (0777, "$ForumsPath/Forum$Number");
mkdir("$ForumsPath/Forum$Number/ANNC", 0777);
chmod (0777, "$ForumsPath/Forum$Number/ANNC");
mkdir("$ForumsPath/Forum$Number/HTML", 0777);
chmod (0777, "$ForumsPath/Forum$Number/HTML");

#create index files to hide contents of directories
open (INDEX, ">$ForumsPath/Forum$Number/ANNC/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$Number/HTML/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$Number/index.html"); 
print INDEX "";
close (INDEX);

#create private directories, if necessary
if ($DIRPW ne "") {
mkdir("$ForumsPath/Forum$Number/private-$DIRPW", 0777);
chmod (0777, "$ForumsPath/Forum$Number/private-$DIRPW");
mkdir("$ForumsPath/Forum$Number/private-$DIRPW/ANNC", 0777);
chmod (0777, "$ForumsPath/Forum$Number/private-$DIRPW/ANNC");
mkdir("$ForumsPath/Forum$Number/private-$DIRPW/HTML", 0777);
chmod (0777, "$ForumsPath/Forum$Number/private-$DIRPW/HTML");

open (INDEX, ">$ForumsPath/Forum$Number/private-$DIRPW/ANNC/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$Number/private-$DIRPW/HTML/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$Number/private-$DIRPW/index.html"); 
print INDEX "";
close (INDEX);
}

##############################
#write other fields to forumstyles.file

$ForumHeader = &LimitReturns($in{'ForumHeader'});
$ForumHeader =~ s/\(/\\(/g;
$ForumHeader =~ s/\)/\\)/g;
$ForumFooter = &LimitReturns($in{'ForumFooter'});
$ForumFooter =~ s/\(/\\(/g;
$ForumFooter =~ s/\)/\\)/g;


open(FORSTYL, ">$ForumsPath/Forum$Number/forumstyles.file");
print FORSTYL ('$BGColor = "' . "$in{'BGColor'}" . '"' . ";\n");
print FORSTYL ('$TextColor = "' . "$in{'TextColor'}" . '"' . ";\n");
print FORSTYL ('$LinkColor = "' . "$in{'LinkColor'}" . '"' . ";\n");
print FORSTYL ('$ActiveLinkColor = "' . "$in{'ActiveLinkColor'}" . '"' . ";\n");
print FORSTYL ('$VisitedLinkColor = "' . "$in{'VisitedLinkColor'}" . '"' . ";\n");
print FORSTYL ('$TableBorderColor = "' . "$in{'TableBorderColor'}" . '"' . ";\n");
print FORSTYL ('$TableStripTextColor = "' . "$in{'TableStripTextColor'}" . '"' . ";\n");
print FORSTYL ('$TableColorStrip = "' . "$in{'TableColorStrip'}" . '"' . ";\n");
print FORSTYL ('$TimeColor = "' . "$in{'TimeColor'}" . '"' . ";\n");
print FORSTYL ('$AltColumnColor1 = "' . "$in{'AltColumnColor1'}" . '"' . ";\n");
print FORSTYL ('$AltColumnColor2 = "' . "$in{'AltColumnColor2'}" . '"' . ";\n");
print FORSTYL ('$CategoryStripColor = "' . "$in{'CategoryStripColor'}" . '"' . ";\n");
print FORSTYL ('$CategoryStripTextColor = "' . "$in{'CategoryStripTextColor'}" . '"' . ";\n");
print FORSTYL ('$CopyrightTextColor = "' . "$in{'CopyrightTextColor'}" . '"' . ";\n");
print FORSTYL ('$FontFace = "' . "$in{'FontFace'}" . '"' . ";\n");
print FORSTYL ('$TableWidth = "' . "$in{'TableWidth'}" . '"' . ";\n");
print FORSTYL ('$TextSize = "' . "$in{'TextSize'}" . '"' . ";\n");
print FORSTYL ('$PageBackground = "' . "$in{'PageBackground'}" . '"' . ";\n");
print FORSTYL ('$BBTitle = "' . "$in{'BBTitle'}" . '"' . ";\n");
print FORSTYL ('$BBTopic = "' . "$in{'BBTopic'}" . '"' . ";\n");
print FORSTYL ('$BBReply = "' . "$in{'BBReply'}" . '"' . ";\n");
print FORSTYL ('$ThreadClosed = "' . "$in{'ThreadClosed'}" . '"' . ";\n");
print FORSTYL ('$profilegif = "' . "$in{'profilegif'}" . '"' . ";\n");
print FORSTYL ('$mailgif = "' . "$in{'mailgif'}" . '"' . ";\n");
print FORSTYL ('$ForumHeader = ' .  "q($ForumHeader);\n");
print FORSTYL ('$ForumFooter = ' . "q($ForumFooter) ;\n");
print FORSTYL "1;";
close(FORSTYL);
chmod(0666, "$ForumsPath/Forum$Number/forumstyles.file");

###########################################



$ConfirmLine = qq(Das $in{'Private'} Forum mit der Nummer $ForumTotal mit dem Namen "$Name" wurde erfolgreich erstellt!<P>Gehe zu: <A HREF="$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true">bersicht der Foren</A> | <A HREF="$CGIURL/cpanel.cgi?action=addforums">Neues Forum erstellen</A> | <A HREF="$CGIURL/cpanel3.cgi?action=cats">Verwaltung der Kategorien</A>);
&ConfirmHTML2;
exit;
} ## END DO ADD NEW FORUM SR


sub InputAreaRow {
my $RowColor = shift;
my $FieldName = shift;
my $Notes = shift;
my $InputField = shift;
my $Cols = shift;
my $Rows = shift;

if ($Notes ne "") {
	$Notes = "<BR>$Notes";
}
print<<ROW;
<TR bgcolor="$RowColor">
<td valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>$FieldName</B></FONT>
<FONT SIZE="1" FACE="Verdana, Arial">$Notes</FONT>
</td>
<td valign=top>
<TEXTAREA NAME="$InputField" COLS="$Cols" ROWS="$Rows" WRAP="VIRTUAL">$$InputField</TEXTAREA>
</td></tr>
ROW
}

sub SendForum {
&VerifyAdminCP($in{'UserNameCheck'}, $in{'PasswordCheck'});
if ($Proceed eq "true") {
	 &DoSendForum;
}  else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("F&uuml;r diese Funktion sind Sie nicht autorisiert.");
}
}

sub DoSendForum {
### write forum info to forums.cgi
$ForumNumber = $in{'ForumNumber'};
$ForumNumber =~ s/\D//g;
$ArrayNumber = $ForumNumber - 1;

&log_admin_activity ("DoSendForum") if ($log_admin_activity eq 'YES');

#read current forum data
@forums = &OpenForumsFile;

	$Found = "false";
	$ThisPrivate = "";
	
foreach $row2(@in) {
	($Name, $Value) = split ("=", $row2);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name eq "Namer") {
		$ThisName = $Value;
		$ThisName =~ s/"/&quot;/g;
		$Found = "true";
	}
	if ($Name eq "Category") {
		$ThisCategory = $Value;
	}
	if ($Name eq "Status") {
		$ThisStatus = $Value;
	}
	if ($Name eq "HTML") {
		$ThisHTML = $Value;
	}
	if ($Name eq "UBB") {
		$ThisUBB = $Value;
	}
	if ($Name eq "TextSize") {
		$TextSize = $Value;
	}
	if ($Name eq "PageBackground") {
		$PageBackground = $Value;
	}
	if ($Name eq "FontFace") {
		$FontFace = $Value;
	}
	if ($Name eq "TableWidth") {
		$TableWidth = $Value;
	}
	if ($Name eq "ModNotify") {
		$ThisModNotify = $Value;
	}
	if ($Name eq "UBBImages") {
		$ThisUBBImages = $Value;
	}
	if ($Name eq "Private") {
		$ThisPrivate = $Value;
	}
	if ($Name eq "TopicRestrict") {
		$ThisTopic = $Value;
	}
	if ($Name eq "ReplyRestrict") {
		$ThisReply = $Value;
	}
	if ($Name eq "forumpw") {
		$ForumPW = $Value;
	if ($ForumPW =~ /\|/) {
		
		eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
	&StandardHTMLCP("In einem Forum-Kennwort d&uuml;rfen Sie das Pipe-Symbol - \"|\" - nicht benutzen - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
}
	}
	if ($Name eq "PrivateMax") {
		$PrivateMax = $Value;
	}
	if ($Name eq "Description") {
		$ThisDescription = $Value;
		$ThisDescription =~ s/"/&quot;/g;
		$ThisDescription =~ s/\n\r\n//g;
		$ThisDescription =~ s/\n//g;
		$ThisDescription =~ s/\r//g;
		$ThisDescription =~ s/  / /g;
	}
} # end foreach $row2


$ThisForumLine = $forums[$ArrayNumber];
chomp($ThisForumLine);
@thisforum = split(/\|/, $ThisForumLine);

#create private directory alternate to keep contents hidden,
#if necessary

if (($ThisPrivate eq "private") && ($thisforum[7] eq "")) {
$DIRPW = &GeneratePassword;
$DescLength = length($ThisDescription);
$DIRPW .= "$DescLength";

mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW");
mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC");
mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML");

open (INDEX, ">$ForumsPath/Forum$thisforum[8]/index.html"); 
print INDEX "";
close (INDEX);

open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/index.html"); 
print INDEX "";
close (INDEX);

}
elsif (($ThisPrivate eq "private") && ($thisforum[7] ne "")) {

$DIRPW = "$thisforum[7]";

unless (-e "$ForumsPath/Forum$thisforum[8]/private-$DIRPW") {

mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW");
mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC");
mkdir("$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML", 0777);
chmod (0777, "$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML");

open (INDEX, ">$ForumsPath/Forum$thisforum[8]/index.html"); 
print INDEX "";
close (INDEX);

open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/ANNC/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/HTML/index.html"); 
print INDEX "";
close (INDEX);
open (INDEX, ">$ForumsPath/Forum$thisforum[8]/private-$DIRPW/index.html"); 
print INDEX "";
close (INDEX);
} # check if exists


}  else {
$DIRPW = "$thisforum[7]";


}

if ($Found eq "true") {
if ($ThisPrivate eq "private") {
	$ThisPermission = "private";
} else {
	$ThisPermission = "$ThisTopic\&$ThisReply";
}
chomp($thisforum[14]);

$forums[$ArrayNumber] = ("$ThisCategory|$ThisName|$ThisDescription|$ThisStatus|$ThisHTML|$ThisUBB|$ThisPermission|$DIRPW|$ForumNumber||$ThisUBBImages|$ThisModNotify|$ForumPW|$PrivateMax|$thisforum[14]\n");
}


#write to forums file

&Lock("lock.file");
open (FORUMS, ">$VariablesPath/forums.cgi"); 
print FORUMS (@forums);
close (FORUMS);
&Unlock("lock.file");

$UserNameCoded = &HTMLIFY($UserNameCheck);
$PasswordCoded = &HTMLIFY($PasswordCheck);

##############################
#write other fields to forumstyles.file

$ForumHeader = &LimitReturns($in{'ForumHeader'});
$ForumHeader =~ s/\(/\\(/g;
$ForumHeader =~ s/\)/\\)/g;

$ForumFooter = &LimitReturns($in{'ForumFooter'});
$ForumFooter =~ s/\(/\\(/g;
$ForumFooter =~ s/\)/\\)/g;

#write other fields to forumstyles.file
open(FORSTYL, ">$ForumsPath/Forum$ForumNumber/forumstyles.file");
if ($in{'RestoreDefaultStyles'} ne "yes") {
print FORSTYL ('$BGColor = "' . "$in{'BGColor'}" . '"' . ";\n");
print FORSTYL ('$TextColor = "' . "$in{'TextColor'}" . '"' . ";\n");
print FORSTYL ('$LinkColor = "' . "$in{'LinkColor'}" . '"' . ";\n");
print FORSTYL ('$ActiveLinkColor = "' . "$in{'ActiveLinkColor'}" . '"' . ";\n");
print FORSTYL ('$VisitedLinkColor = "' . "$in{'VisitedLinkColor'}" . '"' . ";\n");
print FORSTYL ('$TableBorderColor = "' . "$in{'TableBorderColor'}" . '"' . ";\n");
print FORSTYL ('$TableStripTextColor = "' . "$in{'TableStripTextColor'}" . '"' . ";\n");
print FORSTYL ('$TableColorStrip = "' . "$in{'TableColorStrip'}" . '"' . ";\n");
print FORSTYL ('$TimeColor = "' . "$in{'TimeColor'}" . '"' . ";\n");
print FORSTYL ('$AltColumnColor1 = "' . "$in{'AltColumnColor1'}" . '"' . ";\n");
print FORSTYL ('$AltColumnColor2 = "' . "$in{'AltColumnColor2'}" . '"' . ";\n");
print FORSTYL ('$CategoryStripColor = "' . "$in{'CategoryStripColor'}" . '"' . ";\n");
print FORSTYL ('$CategoryStripTextColor = "' . "$in{'CategoryStripTextColor'}" . '"' . ";\n");
print FORSTYL ('$CopyrightTextColor = "' . "$in{'CopyrightTextColor'}" . '"' . ";\n");
print FORSTYL ('$FontFace = "' . "$FontFace" . '"' . ";\n");
print FORSTYL ('$TableWidth = "' . "$TableWidth" . '"' . ";\n");
print FORSTYL ('$TextSize = "' . "$TextSize" . '"' . ";\n");
print FORSTYL ('$PageBackground = "' . "$PageBackground" . '"' . ";\n");
print FORSTYL ('$BBTitle = "' . "$in{'BBTitle'}" . '"' . ";\n");
print FORSTYL ('$BBTopic = "' . "$in{'BBTopic'}" . '"' . ";\n");
print FORSTYL ('$BBReply = "' . "$in{'BBReply'}" . '"' . ";\n");
print FORSTYL ('$ThreadClosed = "' . "$in{'ThreadClosed'}" . '"' . ";\n");
print FORSTYL ('$profilegif = "' . "$in{'profilegif'}" . '"' . ";\n");
print FORSTYL ('$mailgif = "' . "$in{'mailgif'}" . '"' . ";\n");


}  else {

eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
require "Styles.file";

};

print FORSTYL ('$BGColor = "' . "$BGColor" . '"' . ";\n");
print FORSTYL ('$TextColor = "' . "$TextColor" . '"' . ";\n");
print FORSTYL ('$LinkColor = "' . "$LinkColor" . '"' . ";\n");
print FORSTYL ('$ActiveLinkColor = "' . "$ActiveLinkColor" . '"' . ";\n");
print FORSTYL ('$VisitedLinkColor = "' . "$VisitedLinkColor" . '"' . ";\n");
print FORSTYL ('$TableBorderColor = "' . "$TableBorderColor" . '"' . ";\n");
print FORSTYL ('$TableStripTextColor = "' . "$TableStripTextColor" . '"' . ";\n");
print FORSTYL ('$TableColorStrip = "' . "$TableColorStrip" . '"' . ";\n");
print FORSTYL ('$TimeColor = "' . "$TimeColor" . '"' . ";\n");
print FORSTYL ('$AltColumnColor1 = "' . "$AltColumnColor1" . '"' . ";\n");
print FORSTYL ('$AltColumnColor2 = "' . "$AltColumnColor2" . '"' . ";\n");
print FORSTYL ('$CategoryStripColor = "' . "$CategoryStripColor" . '"' . ";\n");
print FORSTYL ('$CategoryStripTextColor = "' . "$CategoryStripTextColor" . '"' . ";\n");
print FORSTYL ('$CopyrightTextColor = "' . "$CopyrightTextColor" . '"' . ";\n");
print FORSTYL ('$FontFace = "' . "$FontFace" . '"' . ";\n");
print FORSTYL ('$TableWidth = "' . "$TableWidth" . '"' . ";\n");
print FORSTYL ('$TextSize = "' . "$TextSize" . '"' . ";\n");
print FORSTYL ('$PageBackground = "' . "$PageBackground" . '"' . ";\n");
print FORSTYL ('$BBTitle = "' . "$BBTitle" . '"' . ";\n");
print FORSTYL ('$BBTopic = "' . "$BBTopic" . '"' . ";\n");
print FORSTYL ('$BBReply = "' . "$BBReply" . '"' . ";\n");
print FORSTYL ('$ThreadClosed = "' . "$ThreadClosed" . '"' . ";\n");
print FORSTYL ('$profilegif = "' . "$profilegif" . '"' . ";\n");
print FORSTYL ('$mailgif = "' . "$mailgif" . '"' . ";\n");

}
print FORSTYL ('$ForumHeader = ' .  "q($ForumHeader);\n");
print FORSTYL ('$ForumFooter = ' .  "q($ForumFooter);\n");
print FORSTYL "1;";
close(FORSTYL);
chmod(0666, "$ForumsPath/Forum$ForumNumber/forumstyles.file");


&EndUpdate("E I N S T E L L U N G &nbsp;&nbsp;&nbsp;&nbsp; D E R &nbsp;&nbsp;&nbsp;&nbsp; F O R E N  &nbsp;&nbsp;&nbsp;&nbsp; A K T U A L I S I E R T", "Vielen Dank! Die Einstellung Ihrer Foren wurde erfolgreich aktualisiert.<P>Um zur &Uuml;bersicht der Foren zur&uuml;ckzukehren, klicken Sie bitte <A HREF=\"$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true\">hier</A>.</FONT>");
exit;

}


sub Cats {
&get_cookie;  #retrieves all current cookies

if ($cookie{UserNameCP}) {
$UserName = "$cookie{UserNameCP}";
$Password = "$cookie{PasswordCP}";
&VerifyAdminCP($UserName, $Password);

if ($Proceed eq "true") {
	&DoCats;
} else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("Sie sind zum Zugriff auf die &Uuml;bersicht der Foren nicht autorisiert.");
exit;
}

} 
elsif ($in{'UserName'} ne "") {

$UserName = "$in{'UserName'}";
$Password = "$in{'Password'}";
&VerifyAdminCP($UserName, $Password);

if ($Proceed eq "true") {
	&DoCats;
} else {
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "Styles.file";

};
&StandardHTMLCP("Sie sind zum Zugriff auf die &Uuml;bersicht der Foren nicht autorisiert.");
exit;
}

}  else {
$PageTitle = "E I N S T E L L U N G &nbsp;&nbsp; D E R &nbsp;&nbsp; K A T E G O R I E N";
$PageIntro = "Um die Einstellung der Kategorien einsehen zu k&ouml;nnen, identifizieren Sie sich bitte. Wir setzen ein Cookie auf Ihren Rechner, so da&szlig; die Identifikation pro Browser-Sitzung einmalig stattfinden wird.";
$HiddenFields = qq(<INPUT TYPE="HIDDEN" NAME="action" VALUE="cats">);
&QueryForID;
exit;
}

} #end Cats sr

sub DoCats {
&AssembleCats;

if ($UserNameCheck ne "") {
$UserNameFill = "$UserNameCheck";
}  else {
$UserNameFill = "$UserName";
}
$UserNameFill = &HTMLIFY($UserNameFill);

if ($PasswordCheck ne "") {
$PasswordFill = "$PasswordCheck";
}  else {
$PasswordFill = "$Password";
}
$PasswordFill = &HTMLIFY($PasswordFill);

if ( ($in{'sortby'} eq "") || ($in{'sortby'} eq "Category")) {
	$SortByCategory = "SELECTED";
	$SortIt = "Category";
}
elsif ($in{'sortby'} eq "Number") {
	$SortByNumber = "SELECTED";
		$SortIt = "Number";
	
}  else {
	$SortByAlpha = "SELECTED";
	$SortIt = "Alpha";
}

$PageTitle = "E I N S T E L L U N G &nbsp;&nbsp; D E R &nbsp;&nbsp; K A T E G O R I E N";
&HEADER2HTML;

print<<CatHTML;
<FONT SIZE="2" FACE="Verdana, Arial">Hier k&ouml;nnen Sie Kategorien erzeugen oder die Reihenfolge der Darstellung der Kategorien bestimmen.  
<P>
Das Feld "Sortierung" stellt die Reihenfolge der Darstellung der Kategorien in der Hauptansicht von UBB dar. M&ouml;chten Sie beispielsweise die Kategorie "Diskussionen um Hardware" als erste anzeigen, geben Sie eine 1 ein usw. Innerhalb der Kategorien wird dann entsprechend der Angaben der dazugeh&ouml;rigen Foren sortiert. Bitte verwenden Sie zur Sortierung ausschlie&szlig;lich numerische Werte.
<P>
Um eine Kategorie zu entfernen, l&ouml;schen Sie einfach das Feld mit der Bezeichnung der Kategorie. 
<P>

<TABLE BORDER=0 width=100%>
<TR><TD align=left valign=bottom><FONT SIZE="2" FACE="Verdana, Arial">
<A HREF="$CGIURL/cpanel.cgi?action=addforums">Forum erstellen</a> | <A HREF="$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true">&Uuml;bersicht der Foren</A></font></TD>
<TD align=right valign=bottom>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="cats">
<SELECT NAME="sortby">
	<OPTION value="Category" $SortByCategory>Sortieren nach Anzeige
	<OPTION value="Number" $SortByNumber>Sortieren nach Forum-Nummer
	<OPTION value="Alpha" $SortByAlpha>Alphabetisch sortieren
</SELECT><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Sortieren">
</FORM>
</td></TR>
</TABLE>
 </FONT>
<P>
<center>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM">
<table border=0 cellpadding=0 cellspacing=0 width="95%"><TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>

<TR bgcolor="Olive"><TD COLSPAN=3 align=center>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="White"><B>&Uuml;BERSICHT DER KATEGORIEN</B></FONT>
</TR>
<TR bgcolor="#B8C6AE">
<TD><FONT SIZE="2" FACE="Verdana, Arial">Nummer</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Name</font></TD>
<TD><FONT SIZE="2" FACE="Verdana, Arial">Sortierung</font></TD>
</TR>
CatHTML

#retreive category list
@CATEGORIES = &OpenFile("$NonCGIPath/categories.file");
####

if ($SortIt eq "Alpha") {
foreach $check(@CATEGORIES) {
@getalpha = split(/\|\|\|/, $check);
$AlphaUC = uc($getalpha[1]);
$AlphaLine = "$AlphaUC||**||$check";
push(@sortthis, $AlphaLine);
}
@sorted = sort(@sortthis);
foreach $uno(@sorted) {
($junk, $keep) = split(/\|\|\*\*\|\|/, $uno);
chomp($keep);
push(@catz, $keep);
}

} 
elsif ($SortIt eq "Number") {
@catz = @CATEGORIES;
}  else {
@catz = sort(@CATEGORIES);
}

foreach $one(@catz) {
($CatOrder, $CatName, $CatNumber) = split(/\|\|\|/, $one);
chomp($CatNumber);
if ($CatOrder eq "") {
	$CatOrder = $CatNumber;
}
$CatOrderSimp = $CatOrder + 0;

print<<ROW;
<TR bgcolor="#FFFFFF">
<TD><FONT SIZE="2" FACE="Verdana, Arial">$CatNumber</font></TD>
<TD><INPUT TYPE="TEXT" NAME="CatName|||$CatNumber" VALUE="$CatName" SIZE=30 MAXLENGTH=100></TD>
<TD><INPUT TYPE="TEXT" NAME="CatOrder|||$CatNumber" VALUE="$CatOrderSimp" SIZE=5 MAXLENGTH=5></TD>
</TR>
ROW

}

print<<BottomForumHTML;
<TR bgcolor="Olive"><TD COLSPAN=3>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="White"><B>Neue Kategorien hinzuf&uuml;gen?</B><BR>Wenn Sie weitere Kategorien erstellen m&ouml;chten, geben Sie diese in dem unten aufgef&uuml;hrten Feld ein. Setzen Sie jede Kategorie in eckige Klammern, also zum Beispiel [Sport] [Hobbies] etc. Wenn Sie dieses Format nicht ber&uuml;cksichtigen, werden die Kategorien nicht erzeugt. M&ouml;chten Sie keine weiteren Kategorien erzeugen, lassen Sie dieses Feld leer.<P><CENTER><INPUT TYPE="TEXT" NAME="NewCats" SIZE=50 MAXLENGTH=400></CENTER></FONT>
</TR>

</table>
</td></tr></table>
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="setcats">

<BR>

<P>
<HR>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Bitte identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></FONT></B>
<p><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern"></form>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000000">Infopop Corporation &copy; 2000<br>Ultimate Bulletin Board $Version</FONT><br><br>
</CENTER></font>
</BODY>
</HTML>
BottomForumHTML
}  ## END DoCats

sub SetCats {

&VerifyAdminCP($in{'UserNameCheck'}, $in{'PasswordCheck'});
if ($Proceed eq "true") {
	 &DoProcessCats;
}
}  ##END SendForums sr

sub DoProcessCats {

&log_admin_activity ("DoProcessCats") if ($log_admin_activity eq 'YES');	
	
foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name =~ m/CatName/) {
	($Trash, $CatNumber) = split(/\|\|\|/, $Name);
	push (@AdjustCats, $CatNumber);
	}
} # end foreach $row

# now we have list of cat numbers to adjust

#read current forum data
my @CATS = &OpenFile("$NonCGIPath/categories.file");

#assemble new line for each revised category
for $num(@AdjustCats) {
chomp($num);
foreach $row2(@in) {
	($Name, $Value) = split ("=", $row2);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name eq "CatName|||$num") {
		$ThisName = $Value;
		$ThisName =~ s/"/&quot;/g;
	}
	if ($Name eq "CatOrder|||$num") {
		$ThisOrderPre = $Value;
		$ThisOrder = &Do6Digit($ThisOrderPre);
	}
} # end foreach $row2

$arrayrow = ($num - 1);

$ThisCatLine = $CATS[$arrayrow];
chomp($ThisForumLine);
@thiscat = split(/\|/, $ThisCatLine);

$CATS[$arrayrow] = ("$ThisOrder|||$ThisName|||$num\n");

}  #end for each @AdjustForum

$TotalCats = @CATS;
$NextCat = $TotalCats + 1;

#check for new cats
if ($in{'NewCats'} ne "") {
my $NewCats = $in{'NewCats'};
$_ = $NewCats;
while (m/(\[)(.*?)(\])/g) {
	push(@matches, $2);
}

foreach $one(@matches) {
if ($one !~ m/(\[|\])/) {
chomp($one);
$NewOrder = &Do6Digit($NextCat);
$CatLine = "$NewOrder|||$one|||$NextCat\n";
push(@CATS, $CatLine);
$NextCat++;
}
}
}

#write to cats file

&Lock("lock.file");
open (FORUMS, ">$NonCGIPath/categories.file"); 
print FORUMS (@CATS);
close (FORUMS);
&Unlock("lock.file");

$UserNameCoded = &HTMLIFY($UserNameCheck);
$PasswordCoded = &HTMLIFY($PasswordCheck);

&EndUpdate("E I N S T E L L U N G &nbsp;&nbsp;&nbsp;&nbsp; D E R  &nbsp;&nbsp;&nbsp;&nbsp; K A T E G O R I E N  &nbsp;&nbsp;&nbsp;&nbsp;  A K T U A L I S I E R T", "Vielen Dank! Die Kategorien wurden erfolgreich aktualisiert!<P><P>Gehe zu: <A HREF=\"$CGIURL/cpanel3.cgi?action=forums&StartPoint=0&inside=true\">&Uuml;bersicht der Foren</A> | <A HREF=\"$CGIURL/cpanel.cgi?action=addforums\">Neues Forum erstellen</A> | <A HREF=\"$CGIURL/cpanel3.cgi?action=cats\">Einstellung der Kategorien</A>");
exit;
} ## END DO PROCESS CATS



sub log_admin_activity { # optional logging of admin activity
my $admin_action = shift;
open(ADMINLOG, ">>$NonCGIPath/BanLists/adminlog.cgi");
print ADMINLOG localtime() . " $admin_action $in{'UserName'}$in{'UserNameCheck'} $ENV{'REMOTE_ADDR'} $ENV{'REMOTE_HOST'} $ENV{'HTTP_USER_AGENT'} $ENV{'HTTP_REFERER'}\n";
close(ADMINLOG);
chmod (0777, "$NonCGIPath/BanLists/adminlog.cgi");
return 1;
} # end SR




exit(0); # comply with SafePerl




